#Makefile objects_model.mk

# Define main source.

MAIN = $(MODEL)/rammain.F90
MAINOBJ = rammain.o


# Define objects.

OBJ_MOD = \
	mem_stilt.o \
	node_mod.o    \
	ModVarfFile.o \
	ModBuffering.o \
	ModMessageData.o \
	ModMessagePassing.o \
	ModMessageSet.o \
	ModGridDims.o \
	ModGrid.o \
	ModGridTree.o \
	ModNeighbourNodes.o \
	ModFieldSectionList.o \
	ModDomainDecomp.o \
	ModDateUtils.o \
	ReadBcst.o \
	mpi_io_engine-5d.o \
	Phys_const.o \
	alloc.o   \
	an_header.o \
	aobj.o \
	asgen.o \
	asti.o \
	asti2.o \
	astp.o \
	avarf.o \
	ccatt_start.o \
	machine_arq.o \
	teb_spm_start.o \
	mem_grid_dim_defs.o \
	cond_read.o \
	cond_update.o \
	conv_coms.o \
	coriolis.o \
	cu_read.o \
	cup_dn.o \
	cup_env.o \
	cup_env_catt.o \
	cup_grell_catt_deep.o \
	cup_grell_catt_shallow.o \
	cup_output_vars.o \
	cup_up.o \
	diffsclr.o \
	diffuse.o \
	file_inv.o \
	first_rams.o \
	geodat.o \
	grid_dims.o \
	grid_struct.o \
	inithis.o  \
	io_params.o \
	isan_coms.o \
	isan_io.o \
	ke_coms.o \
	landuse_input.o \
	leaf3.o \
	leaf3_hyd.o \
	leaf3_init.o \
	leaf_coms.o \
	leaf3_teb.o \
	mem_aerad.o \
	mem_all.o \
	mem_basic.o \
	carma_driver.o \
	mem_carma.o \
	mem_cuparm.o \
	mem_cutrans.o \
	mem_globaer.o \
	mem_globrad.o \
	mem_grell.o \
	mem_grell_param2.o \
	mem_grid.o \
	mem_leaf.o \
	mem_micro.o \
	mem_mksfc.o \
	mem_nestb.o \
	mem_oda.o \
	mem_opt_scratch.o \
	mem_precision.o \
	mem_radiate.o \
	mem_scalar.o \
	mem_scratch.o \
	mem_scratch1_brams.o \
	mem_scratch1_grell.o \
	mem_scratch2_grell.o \
	mem_scratch2_grell_sh.o \
	mem_scratch3_grell.o \
	mem_scratch3_grell_sh.o \
	mem_shcu.o \
	mem_tconv.o \
	mem_tend.o \
	mem_turb.o \
	mem_turb_scalar.o \
	mem_varinit.o \
	mem_micro_optij.o \
	mic_coll.o \
	mic_driv.o \
	mic_driv_new.o \
	mic_gamma.o \
	mic_init.o \
	mic_misc.o \
	mic_nuc.o \
	mic_tabs.o \
	mic_vap.o \
	micphys.o \
	mksfc_driver.o \
	mksfc_ndvi.o \
	mksfc_sfc.o \
	mksfc_sst.o \
	mksfc_top.o \
	ModTimeStamp.o \
	modsched.o \
	local_proc.o \
	mpass_dtl.o \
	mpass_feed.o \
	mpass_full.o      \
	mpass_nest.o \
	ndvi_read.o \
	nest_drivers.o \
	nest_feed.o \
	nest_filldens.o \
	nest_geosst.o \
	nest_intrp.o \
	nud_analysis.o \
	nud_read.o \
	nud_update.o \
	obs_input.o \
	oda_krig.o \
	oda_nudge.o \
	oda_proc_obs.o \
	oda_read.o \
	oda_sta_count.o \
	oda_sta_input.o \
	opspec.o \
	domain_decomp.o \
	para_init.o \
	Phys_const.o \
	raco.o \
	raco_adap.o \
	rad_carma.o \
	rad_driv.o \
	rtm_driver.o \
	radvc.o \
	radvc_rk.o \
	radvc_adap.o \
	radvc_mnt.o \
	mod_GhostBlock.o \
	mod_GhostBlockPartition.o \
	mod_advect_kit.o \
	radvc_new.o \
	rams_grid.o \
	gridset.o \
	adap_init.o \
	ModOneProc.o \
	rams_mem_alloc.o   \
	rams_read_header.o \
	ranlavg.o \
	rbnd.o \
	rbnd_adap.o \
	rcio.o \
	rconstants.o \
	rconv.o \
	rconv_grell_catt.o \
	chem_conv_transp.o \
	ModNamelistFile.o  \
	ModParallelEnvironment.o  \
	read_ralph.o \
	recycle.o  \
	ref_sounding.o \
	refstate.o \
	rgrad.o \
	rhhi.o  \
	rinit.o  \
	rio.o \
	rnest_par.o \
	rnode.o \
	rshcupar.o \
	rthrm.o \
	rtimh.o \
	rtimh_rk.o \
	rtimh_abm.o \
	rtimi.o \
	ruser.o \
	shcu_vars_const.o \
	memSoilMoisture.o \
	soilMoisture.o \
	sst_read.o \
	turb_diff.o \
	turb_diff_adap.o \
	turb_k.o \
	turb_k_adap.o \
	turb_ke.o \
	upcase.o \
	urban_canopy.o \
	v_interps.o \
	extra.o \
	aer1_list.o \
	mem_aer1.o \
	chem1_list.o \
	chem1aq_list.o \
	mem_chem1aq.o \
	mem_chem1.o \
	mem_chemic.o \
	mem_plume_chem1.o \
	mem_volc_chem1.o \
	chem_sources.o \
	chem_plumerise_scalar.o \
	ChemSourcesDriver.o \
	chem_dry_dep.o \
	ChemDryDepDriver.o \
	mem_tuv.o \
	tuvParameter.o \
	ModTuv2.7.o \
	ModTuvDriver2.7.o \
	var_tables.o \
	varf_update.o \
	vtab_fill.o \
	mksfc_fuso.o \
	mem_teb.o \
	mem_teb_common.o \
	mem_teb_vars_const.o \
	mem_gaspart.o \
	mem_emiss.o \
	urban.o \
	gaspart.o \
	ozone.o \
	mod_ozone.o \
	chem_isan_coms.o \
	chem_aobj.o \
	chem_asgen.o \
	chem_asti2.o \
	chem_asti.o \
	chem_astp.o \
	chem_avarf.o \
	chem_file_inv.o \
	chem_first_rams.o \
	chem_isan_io.o \
	chem_refstate.o \
	chem_v_interps.o \
	carma_fastjx.o \
	chem_fastjx57.o \
	chem_fastjx_data.o \
	chem_fastjx_driv.o \
	chem_spack_utils.o \
	mem_spack.o \
	chem_uv_att.o\
	chem_spack_solve_sparse.o \
	chem_spack_lu.o \
	chem_spack_jacdchemdc.o \
	chem_spack_dratedc.o \
	chem_spack_kinetic.o \
	chem_spack_fexprod.o \
	chem_spack_fexloss.o \
	chem_spack_rates.o \
	chem_spack_fexchem.o \
	chem_spack_ros.o \
	chem_spack_ros_dyndt.o \
	chem_spack_rodas3_dyndt.o\
	chem_spack_qssa.o \
	chem_trans_gasaq.o \
	chem_trans_liq.o \
	chem_orage.o \
	chemistry.o \
	ModPostProcess.o \
	ModPostOneField.o \
	ModPostOneField2d.o \
	ModPostOneField3d.o \
	ModPostOneField7d.o \
	ModPostOneField8d.o \
	ModPostOneFieldUtils.o \
	ModPostUtils.o \
	ModPostGrid.o \
	ModBramsGrid.o \
	ModOutputUtils.o \
	kbcon_ecmwf.o \
	module_cu_g3.o \
	module_cu_gf.o \
	module_cu_gf_v5.1.o \
	module_cu_gd_fim.o \
	cup_grell3.o \
	rexev.o \
	rstilt.o \
	turb_constants.o \
	tkenn.o \
	digitalFilter.o \
	GridMod.o \
	MapMod.o \
	ProcessorMod.o \
	BoundaryMod.o \
	errorMod.o \
	advSendMod.o \
	InitAdvect.o \
	seasalt.o  \
	meteogram.o \
	meteogramType.o \
	mcica_random_numbers.o \
	mcica_subcol_gen_sw.o \
	parkind.o \
	parrrsw.o \
	rrsw_aer.o \
	rrsw_cld.o \
	rrsw_con.o \
	rrsw_kg16.o \
	rrsw_kg17.o \
	rrsw_kg18.o \
	rrsw_kg19.o \
	rrsw_kg20.o \
	rrsw_kg21.o \
	rrsw_kg22.o \
	rrsw_kg23.o \
	rrsw_kg24.o \
	rrsw_kg25.o \
	rrsw_kg26.o \
	rrsw_kg27.o \
	rrsw_kg28.o \
	rrsw_kg29.o \
	rrsw_ref.o \
	rrsw_tbl.o \
	rrsw_vsn.o \
	rrsw_wvn.o \
	rrtmg_sw_cldprmc.o \
	rrtmg_sw_cldprop.o \
	rrtmg_sw_init.o \
	rrtmg_sw_k_g.o \
	rrtmg_sw_rad.o \
	rrtmg_sw_reftra.o \
	rrtmg_sw_setcoef.o \
	rrtmg_sw_spcvmc.o \
	rrtmg_sw_spcvrt.o \
	rrtmg_sw_taumol.o \
	rrtmg_sw_vrtqdr.o \
	mcica_subcol_gen_lw.o \
	parrrtm.o \
	rrlw_cld.o \
	rrlw_con.o \
	rrlw_kg01.o \
	rrlw_kg02.o \
	rrlw_kg03.o \
	rrlw_kg04.o \
	rrlw_kg05.o \
	rrlw_kg06.o \
	rrlw_kg07.o \
	rrlw_kg08.o \
	rrlw_kg09.o \
	rrlw_kg10.o \
	rrlw_kg11.o \
	rrlw_kg12.o \
	rrlw_kg13.o \
	rrlw_kg14.o \
	rrlw_kg15.o \
	rrlw_kg16.o \
	rrlw_ncpar.o \
	rrlw_ref.o \
	rrlw_tbl.o \
	rrlw_vsn.o \
	rrlw_wvn.o \
	rrtmg_lw_cldprmc.o \
	rrtmg_lw_cldprop.o \
	rrtmg_lw_init.o \
	rrtmg_lw_k_g.o \
	rrtmg_lw_rad.o \
	rrtmg_lw_rtrn.o \
	rrtmg_lw_rtrnmc.o \
	rrtmg_lw_rtrnmr.o \
	rrtmg_lw_setcoef.o \
	rrtmg_lw_taumol.o \
	mem_rrtm.o \
	isrpia.o \
	quad.o \
	actv.o \
	coag.o \
	depv.o \
	diam.o \
	dicrete.o \
	init.o \
	solut.o \
	issoropia.o \
	isofwd.o \
	isorev.o \
	matrix.o \
	npf.o \
	quad.o \
	setup.o \
	subs.o \
	thermo_isorr.o \
	isrpia.o \
	MatrixDriver.o \
	ModParticle.o \
	memMatrix.o\
	module_rams_microphysics_2M.o\
	mic_thompson_driver.o\
	module_mp_thompson.o\
	module_mp_radar.o \
	module_wind_farm.o \
	module_wind_fitch.o \
	initComm.o \
	debugTools.o \
	imogen_map.o \
	imogen_anlg_vals.o \
	imogen_constants.o \
	imogen_run.o \
	imogen_time.o \
	imogen_clim.o \
	imogen_drive_vars.o \
	imogen_io_vars.o \
	imogen_progs.o \
	clim_calc.o \
	day_calc.o \
	delta_temp.o \
	diffcarb_land.o \
	drdat.o \
	gcm_anlg.o \
	imogen_check.o \
	imogen_confirmed_run.o \
	imogen_update_carb.o \
	imogen_update_clim.o \
	invert.o \
	ocean_co2.o \
	radf_co2.o \
	radf_non_co2.o \
	redis.o \
	response.o \
	rndm.o \
	solang.o \
	solpos.o \
	sunny.o \
	aero.o \
	ancil_info.o \
	blopt8a.o \
	coastal.o \
	c_elevate.o \
	diag_swchs.o \
	drive_io_vars.o \
	earth_utils.o \
	file_utils.o \
	fluxes.o \
	forcing.o \
	grid_utils.o \
	initial_mod.o \
	inout.o \
	jules_netcdf.o \
	misc_utils.o \
	offline_diag.o \
	orog.o \
	output_mod.o \
	ozone_vars.o \
	prognostics.o \
	p_s_parms.o \
	readwrite_mod.o \
	rwerr_mod.o \
	route_mod.o \
	screen.o \
	sea_ice.o \
	spin_mod.o \
	switches.o \
	switches_urban.o \
	time_loc.o \
	time_mod.o \
	top_pdm.o \
	trifctl.o \
	u_v_grid.o \
	update_mod.o \
	veg_io_vars.o \
	solinc_data.o \
	um_types.o \
	jules_mod.o \
	blend_h.o \
	c_0_dg_c.o \
	c_ch4.o \
	c_charnk.o \
	c_densty.o \
	c_epslon.o \
	c_g.o \
	c_gamma.o \
	c_ht_m.o \
	c_kappai.o \
	c_lheat.o \
	c_mdi.o \
	c_pdm.o \
	c_perma.o \
	c_pi.o \
	c_r_cp.o \
	c_rhowat.o \
	c_rmol.o \
	c_rough.o \
	c_sicehc.o \
	c_sulchm.o \
	c_surf.o \
	c_topog.o \
	c_vkman.o \
	c_z0h_z0m.o \
	caoptr.o \
	ccarbon.o \
	csigma.o \
	csmin.o \
	descent.o \
	dust_param.o \
	dust_parameters_mod.o \
	fldtype.o \
	max_dimensions.o \
	nstypes.o \
	nvegparm.o \
	nvegparm_io.o \
	pftparm.o \
	pftparm_io.o \
	rad_param.o \
	seed.o \
	sigm.o \
	snow_param.o \
	soil_param.o \
	surf_param.o \
	timeconst.o \
	trif.o \
	trif_io.o \
	urban_param.o \
	veg_param.o \
	atmos_constants_mod.o \
	conversions_mod.o \
	earth_constants_mod.o \
	water_constants_mod.o \
	allocate_arrays.o \
	control.o \
	deallocate_arrays.o \
	do_areaver.o \
	jules.o \
	jules_final.o \
	newtime.o \
	pre_areaver.o \
	spin_check.o \
	timer.o \
	zenith_mod.o \
	calc_fit_fsat.o \
	freeze_soil.o \
	init.o \
	init_agric.o \
	init_drive.o \
	init_frac.o \
	init_grid_mod.o \
	init_hgt.o \
	init_misc.o \
	init_nonveg.o \
	init_opts.o \
	init_out.o \
	init_parms.o \
	init_pdm.o \
	init_route.o \
	init_snow.o \
	init_soil.o \
	init_soil_lut.o \
	init_time.o \
	init_top.o \
	init_trif.o \
	init_vars_tmp.o \
	init_veg.o \
	init_out_varlist.o \
	init_out_time.o \
	init_out_map_mod.o \
	init_out_var.o \
	init_out_check.o \
	init_urban.o \
	init_imogen.o \
	albpft.o \
	albsnow.o \
	ftsa.o \
	tile_albedo.o \
	canyonalb.o \
	matinv.o \
	urbanemis.o \
	canopysnow.o \
	compactsnow.o \
	layersnow.o \
	relayersnow.o \
	snow.o \
	snowgrain.o \
	snowpack.o \
	snowtherm.o \
	tridag.o \
	calc_baseflow_jules.o \
	calc_fsat.o \
	calc_zw.o \
	ch4_wetl.o \
	darcy_ch.o \
	darcy_ic.o \
	darcy_vg.o \
	frunoff.o \
	gauss.o \
	heat_con.o \
	hyd_con_ch.o \
	hyd_con_ic.o \
	hyd_con_vg.o \
	hydrol.o \
	ice_htc.o \
	pdm.o \
	routing.o \
	sieve.o \
	soil_htc.o \
	soil_hyd.o \
	soilmc.o \
	soilt.o \
	surf_hyd.o \
	cancap.o \
	dewpnt.o \
	dustresb.o \
	elevate.o \
	fcdch.o \
	generate_anthrop_heat.o \
	im_sf_pt.o \
	leaf.o \
	leaf_limits.o \
	leaf_lit.o \
	microbe.o \
	phi_m_h.o \
	phi_m_h_vol.o \
	physiol.o \
	qsat.o \
	qsat_mix.o \
	qsat_wat.o \
	raero.o \
	root_frac.o \
	screen_tq.o \
	sf_aero.o \
	sf_evap.o \
	sf_exch.o \
	sf_expl.o \
	sf_flux.o \
	sf_impl.o \
	sf_melt.o \
	sf_orog.o \
	sf_orog_gb.o \
	sf_resist.o \
	sf_rib.o \
	sf_stom.o \
	sfl_int.o \
	sice_htf.o \
	smc_ext.o \
	soil_evap.o \
	stdev1.o \
	vgrav.o \
	urbanz0.o \
	get_us.o \
	compete.o \
	decay.o \
	dpm_rpm.o \
	growth.o \
	lotka.o \
	pft_sparm.o \
	phenol.o \
	soilcarb.o \
	sparm.o \
	tilepts.o \
	triffid.o \
	veg-veg1a.o \
	veg-veg2a.o \
	vegcarb.o \
	parkind1.o \
	yomhook.o \
	ConvPar_GF_GEOS5.o \
	Henrys_Law_cts.o \
	MAPL_Constants.o \
	optical.o        \
	mic_gfdl_driver.o \
	gfdl_cloud_microphys.o \
	dam.o \
	mod_aer.o \
	initMicThompson.o \
	ModPostGridNetCDF.o \
	ModPostOneFieldNetCDF.o \
	ModPostTypes.o \
	ModEvaluation.o \
	modIau.o \
	leaf3_ocean_only.o

	JULES_OBJ_SFCLYR = sfclyr_jules.o
	JULES_OBJ_MEM    = mem_jules.o
	JULES_OBJ_FLX   = fluxes.o
ifeq ($(ENABLEJULES),false)
	JULES_OBJ_SFCLYR =
	JULES_OBJ_MEM    =
	JULES_OBJ_FLX   =
endif

ifeq ($(NETCDFFDIR),)
	OBJ_MODEL =  jules_netcdf_dummy.o $(OBJ_MOD) 
else
	OBJ_MODEL = $(OBJ_MOD)
endif

MOD_MOD = \
	mod_chem_spack_rodas3_dyndt.mod   \
	dump.mod \
	moddateutils.mod \
	an_header.mod \
	hdf5_utils.mod \
	modmemory.mod \
	parlib.mod \
	satpolycolision.mod \
	module_gate.mod \
	gammafunction.mod \
	grid_dims.mod \
	modparallelenvironment.mod \
	modnamelistfile.mod \
	rconstants.mod \
	io_params.mod \
	var_tables.mod \
	mem_stilt.mod \
	mem_grid.mod \
	modgriddims.mod \
	moddomaindecomp.mod \
	modneighbournodes.mod \
	modfieldsectionlist.mod \
	modmessagedata.mod \
	modbuffering.mod \
	modmessageset.mod \
	modmessagepassing.mod \
	meteogramtype.mod \
	modgrid.mod \
	modgridtree.mod \
	node_mod.mod \
	mem_grid_dim_defs.mod \
	mem_aerad.mod \
	mem_radiate.mod \
	mem_scratch.mod \
	ref_sounding.mod \
	chem1_list.mod \
	mem_chem1.mod \
	mem_varinit.mod \
	mem_basic.mod \
	mem_turb.mod \
	mem_precision.mod \
	mem_globrad.mod \
	conv_coms.mod \
	shcu_vars_const.mod \
	domain_decomp.mod \
	isan_coms.mod \
	mem_cuparm.mod \
	mem_grell_param.mod \
	teb_spm_start.mod \
	mem_leaf.mod \
	mem_oda.mod \
	memsoilmoisture.mod \
	micphys.mod \
	mem_emiss.mod \
	teb_vars_const.mod \
	readbcst.mod \
	aer1_list.mod \
	mem_aer1.mod \
	modvarffile.mod \
	mpi_io_engine.mod \
	phys_const.mod \
	mem_micro.mod \
	mem_scalar.mod \
	mem_scratch1.mod \
	mem_gaspart.mod \
	mem_tend.mod \
	mem_nestb.mod \
	mem_all.mod \
	mem_opt.mod \
	mem_shcu.mod \
	mem_globaer.mod \
	mem_teb.mod \
	mem_teb_common.mod \
	mem_jules.mod \
	ccatt_start.mod \
	machine_arq.mod \
	grid_struct.mod \
	cup_output_vars.mod \
	mem_scratch2_grell.mod \
	mem_scratch3_grell.mod \
	mem_carma.mod \
	kbcon_ecmwf.mod \
	mem_scratch2_grell_sh.mod \
	mem_scratch3_grell_sh.mod \
	ke_coms.mod \
	leaf_coms.mod \
	mem_mksfc.mod \
	carma_fastjx.mod \
	tuvparameter.mod \
	modtuv.mod \
	mem_tuv.mod \
	rad_carma.mod \
	mem_scratch1_grell.mod \
	carma_driv.mod \
	mem_cutrans.mod \
	mem_grell.mod \
	mem_tconv.mod \
	mem_turb_scalar.mod \
	mem_micro_opt.mod \
	mem_chemic.mod \
	chem1aq_list.mod \
	mem_chem1aq.mod \
	modtimestamp.mod \
	dtset.mod \
	soilmoisture.mod \
	modevaluation.mod \
	obs_input.mod \
	mem_plume_chem1.mod \
	mem_volc_chem1.mod \
	chem_sources.mod \
	modacoust_adap.mod \
	modcomm.mod \
	modacoust.mod \
	parkind.mod \
	parrrsw.mod \
	rrsw_aer.mod \
	rrsw_cld.mod \
	rrsw_con.mod \
	rrsw_kg16.mod \
	rrsw_kg17.mod \
	rrsw_kg18.mod \
	rrsw_kg19.mod \
	rrsw_kg20.mod \
	rrsw_kg21.mod \
	rrsw_kg22.mod \
	rrsw_kg23.mod \
	rrsw_kg24.mod \
	rrsw_kg25.mod \
	rrsw_kg26.mod \
	rrsw_kg27.mod \
	rrsw_kg28.mod \
	rrsw_kg29.mod \
	rrsw_tbl.mod \
	rrsw_vsn.mod \
	rrsw_wvn.mod \
	rrsw_ref.mod \
	rrtmg_sw_setcoef.mod \
	rrtmg_sw_init.mod \
	parrrtm.mod \
	rrlw_cld.mod \
	rrlw_con.mod \
	rrlw_kg01.mod \
	rrlw_kg02.mod \
	rrlw_kg03.mod \
	rrlw_kg04.mod \
	rrlw_kg05.mod \
	rrlw_kg06.mod \
	rrlw_kg07.mod \
	rrlw_kg08.mod \
	rrlw_kg09.mod \
	rrlw_kg10.mod \
	rrlw_kg11.mod \
	rrlw_kg12.mod \
	rrlw_kg13.mod \
	rrlw_kg14.mod \
	rrlw_kg15.mod \
	rrlw_kg16.mod \
	rrlw_tbl.mod \
	rrlw_vsn.mod \
	rrlw_wvn.mod \
	rrlw_ref.mod \
	rrtmg_lw_setcoef.mod \
	rrtmg_lw_init.mod \
	mem_rrtm.mod \
	mersennetwister.mod \
	mcica_random_numbers.mod \
	mcica_subcol_gen_sw.mod \
	rrtmg_sw_cldprmc.mod \
	rrtmg_sw_reftra.mod \
	rrtmg_sw_taumol.mod \
	rrtmg_sw_vrtqdr.mod \
	rrtmg_sw_spcvmc.mod \
	rrtmg_sw_rad.mod \
	mcica_subcol_gen_lw.mod \
	rrtmg_lw_cldprmc.mod \
	rrtmg_lw_rtrnmc.mod \
	rrtmg_lw_taumol.mod \
	rrtmg_lw_rad.mod \
	rrtmg_lw_cldprop.mod \
	rrtmg_sw_cldprop.mod \
	optical.mod \
	rrtm_driv.mod \
	radiation.mod \
	extras.mod \
	module_dry_dep.mod \
	advmessagemod.mod \
	monotonic_adv.mod \
	advrkparam.mod \
	mod_ghostblockpartition.mod \
	mod_ghostblock.mod \
	advect_kit.mod \
	errormod.mod \
	gridmod.mod \
	mapmod.mod \
	processormod.mod \
	boundarymod.mod \
	advectdata.mod \
	modoutpututils.mod \
	modpostutils.mod \
	modbramsgrid.mod \
	modposttypes.mod \
	modpostgridnetcdf.mod \
	modpostonefieldnetcdf.mod \
	modpostgrid.mod \
	modpostonefieldutils.mod \
	modpostonefield2d.mod \
	modpostonefield3d.mod \
	modpostonefield7d.mod \
	modpostonefield8d.mod \
	modpostonefield.mod \
	modpostprocess.mod \
	module_cu_g3.mod \
	module_cu_gd_fim.mod \
	module_cu_gf.mod \
	module_cu_gf2.mod \
	mapl_constantsmod.mod \
	henrys_law_constantsmod.mod \
	convpar_gf_geos5.mod \
	cuparm_grell3.mod \
	digitalfilter.mod \
	jx_data.mod \
	fastjx57.mod \
	fastjx.mod \
	modtuvdriver.mod \
	mod_chem_plumerise_scalar.mod \
	chemsourcesdriver.mod \
	chemdrydepdriver.mod \
	spack_utils.mod \
	mem_spack.mod \
	solve_sparse.mod \
	lu.mod \
	mod_chem_spack_dratedc.mod \
	mod_chem_spack_jacdchemdc.mod \
	mod_chem_spack_kinetic.mod \
	mod_chem_spack_rates.mod \
	mod_chem_spack_fexchem.mod \
	uv_atten.mod \
	mod_chem_spack_ros.mod \
	mod_chem_spack_ros_dyndt.mod \
	mod_chem_spack_fexloss.mod \
	mod_chem_spack_fexprod.mod \
	mod_chem_spack_qssa.mod \
	mod_chem_trans_gasaq.mod \
	mod_chem_orage.mod \
	mod_chem_trans_liq.mod \
	module_chemistry_driver.mod \
	rams_microphysics_2m.mod \
	module_mp_radar.mod \
	module_mp_thompson.mod \
	module_wind_fitch.mod \
	wind_farm.mod \
	aerclimmod.mod \
	seasalt.mod \
	memmatrix.mod \
	aero_setup.mod \
	aero_subs.mod \
	aero_diam.mod \
	aero_coag.mod \
	aero_npf.mod \
	modparticle.mod \
	aero_isrpia.mod \
	drivermatrix.mod \
	nstypes.mod \
	csigma.mod \
	ancil_info.mod \
	water_constants_mod.mod \
	c_densty.mod \
	seed.mod \
	trifctl.mod \
	imogen_constants.mod \
	imogen_progs.mod \
	inout.mod \
	rwerr_mod.mod \
	switches.mod \
	time_loc.mod \
	jules_netcdf.mod \
	file_utils.mod \
	max_dimensions.mod \
	soil_param.mod \
	timeconst.mod \
	time_mod.mod \
	misc_utils.mod \
	nvegparm.mod \
	p_s_parms.mod \
	pftparm.mod \
	prognostics.mod \
	route_mod.mod \
	grid_utils.mod \
	readwrite_mod.mod \
	spin_mod.mod \
	snow_param.mod \
	top_pdm.mod \
	switches_urban.mod \
	urban_param.mod \
	initial_mod.mod \
	aero.mod \
	dust_parameters_mod.mod \
	dust_param.mod \
	c_z0h_z0m.mod \
	coastal.mod \
	drive_io_vars.mod \
	fluxes.mod \
	forcing.mod \
	offline_diag.mod \
	orog.mod \
	screen.mod \
	c_elevate.mod \
	trif.mod \
	u_v_grid.mod \
	veg_io_vars.mod \
	atmos_constants_mod.mod \
	c_epslon.mod \
	c_lheat.mod \
	c_r_cp.mod \
	earth_constants_mod.mod \
	c_g.mod \
	surf_param.mod \
	ozone_vars.mod \
	imogen_time.mod \
	imogen_clim.mod \
	imogen_drive_vars.mod \
	jules_mod.mod \
	alloc_mod.mod \
	init_grid_mod.mod \
	conversions_mod.mod \
	c_0_dg_c.mod \
	output_mod.mod \
	update_mod.mod \
	modtimestep.mod \
	modtimestep_rk.mod \
	modtimestep_abm.mod \
	meteogram.mod \
	dam.mod \
	initmicthompson.mod \
	modoneproc.mod \
	turb_constants.mod \
	ozone_const.mod \
	chem_isan_coms.mod \
	rrtmg_sw_spcvrt.mod \
	rrlw_ncpar.mod \
	rrtmg_lw_rtrn.mod \
	rrtmg_lw_rtrnmr.mod \
	aero_actv.mod \
	aero_depv.mod \
	aero_discrete.mod \
	solut.mod \
	casej.mod \
	caseg.mod \
	isorropia_module.mod \
	debugdata.mod \
	imogen_map.mod \
	imogen_anlg_vals.mod \
	imogen_run.mod \
	imogen_io_vars.mod \
	c_pi.mod \
	blopt8a.mod \
	diag_swchs.mod \
	earth_utils.mod \
	sea_ice.mod \
	solinc_data.mod \
	um_types.mod \
	blend_h.mod \
	c_ch4.mod \
	c_charnk.mod \
	c_gamma.mod \
	c_ht_m.mod \
	c_kappai.mod \
	c_mdi.mod \
	c_pdm.mod \
	c_perma.mod \
	c_rhowat.mod \
	c_rmol.mod \
	c_rough.mod \
	c_sicehc.mod \
	c_sulchm.mod \
	c_surf.mod \
	c_topog.mod \
	c_vkman.mod \
	caoptr.mod \
	ccarbon.mod \
	csmin.mod \
	descent.mod \
	fldtype.mod \
	nvegparm_io.mod \
	pftparm_io.mod \
	rad_param.mod \
	sigm.mod \
	trif_io.mod \
	veg_param.mod \
	zenith_mod.mod \
	init_out_map_mod.mod \
	parkind1.mod \
	yomhook.mod \
	gfdl_cloud_microphys_mod.mod \
	modIau.mod \
	leaf3_ocean_only.mod

ifeq ($(NETCDFFDIR),)
	MOD_MODEL =  netcdf.mod $(MOD_MOD) 
else
	MOD_MODEL = $(MOD_MOD)
endif

