  
 MODULE mod_chem_spack_rates
  
   IMPLICIT NONE
   PRIVATE
   PUBLIC :: rates ! subroutine
 CONTAINS
  
   SUBROUTINE rates(rk,y,w,ngas,ijkbeg,ijkend,maxblock_size,nr)
 
!------------------------------------------------------------------------
!
!     -- DESCRIPTION
!
!     This routine computes the reaction rates.
!     This routine is automatically generated by SPACK.
!     Mechanism: ../Mechanism/CB07   
!     Species: ../Mechanism/ciCB07 
!
!------------------------------------------------------------------------
!
!     -- INPUT VARIABLES
!
!     RK: kinetic rates.
!     Y: chemical concentrations.
!
!     -- INPUT/OUTPUT VARIABLES
!
!     -- OUTPUT VARIABLES
!
!     W: reaction rates.
!
!------------------------------------------------------------------------
!
!     -- REMARKS
!
!------------------------------------------------------------------------
!
!     -- MODIFICATIONS
!
!------------------------------------------------------------------------
!
!     -- AUTHOR(S)
!
!     SPACK.
!
!------------------------------------------------------------------------
 
      IMPLICIT NONE
 
 
 
      INTEGER  	, INTENT(IN)  :: ngas	               
      INTEGER  	, INTENT(IN)  :: ijkbeg 	       
      INTEGER  	, INTENT(IN)  :: ijkend 	       
      INTEGER  	, INTENT(IN)  :: maxblock_size	       
      INTEGER  	, INTENT(IN)  :: nr		       
      DOUBLE PRECISION , INTENT(IN)  :: rk(maxblock_size,nr)  
      DOUBLE PRECISION , INTENT(IN)  :: y(maxblock_size,NGAS) 
      DOUBLE PRECISION , INTENT(OUT) :: w(maxblock_size,nr)   

 
   END SUBROUTINE rates
 
  END MODULE mod_chem_spack_rates
 
